<?php

namespace NL\NlMenubuilder\ViewHelpers\Menu;

use FluidTYPO3\Vhs\Traits\TemplateVariableViewHelperTrait;
use NL\NlMenubuilder\Domain\Repository\MenuRepository;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Extbase\Object\ObjectManager;
use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper;
use TYPO3Fluid\Fluid\Core\ViewHelper\Traits\CompileWithRenderStatic;

class GetViewHelper extends AbstractViewHelper
{
    use CompileWithRenderStatic;
    use TemplateVariableViewHelperTrait;

    /**
     * @var boolean
     */
    protected $escapeChildren = false;

    /**
     * @var boolean
     */
    protected $escapeOutput = false;

    /**
     * @return void
     */
    public function initializeArguments(): void
    {
        $this->registerAsArgument();
        $this->registerArgument('uid', 'int', 'UID of the menu', true, 0);
    }

    /**
     * @param array $arguments
     * @param \Closure $renderChildrenClosure
     * @param RenderingContextInterface $renderingContext
     * @return mixed|string
     * @throws \TYPO3\CMS\Extbase\Object\Exception
     */
    public static function renderStatic(array $arguments, \Closure $renderChildrenClosure, RenderingContextInterface $renderingContext)
    {
        /** @var ObjectManager $objectManager */
        $objectManager = GeneralUtility::makeInstance(ObjectManager::class);

        /** @var MenuRepository $menuRepository */
        $menuRepository = $objectManager->get(MenuRepository::class);

        return static::renderChildrenWithVariableOrReturnInputStatic(
            $menuRepository->findByUid($arguments['uid'] ?? 0),
            $arguments['as'],
            $renderingContext,
            $renderChildrenClosure
        );
    }
}
